#include <conio.h>//cprintf, ...
#include <io.h>//read, ...
#include <fcntl.h>//O_BINARY, ...
#include <alloc.h>//alloc, ...
#include <process.h>//exit
#include <string.h>//strupr
#include <ctype.h>//toupper
#include <dir.h>//findfirst, ...
#include <stdio.h>//fflush, ...

#ifndef byte
#define byte

 typedef unsigned char Byte;

#endif

#ifndef word
#define word

 typedef unsigned short Word;

#endif

#ifndef dword
#define dword

 typedef unsigned long DWord;

#endif

 typedef char fNameStr[80];

 struct FileInfo {
  char *Name;
  DWord Size;
 };//FileInfo

 struct tEncDictItem {
  Byte Letter;
  Word Succ;
  Word Neib;
 };//tEncDictItem

 struct tDecDictItem {
  Byte Letter;
  Word Pred;
 };//tDecDictItem

 const char *IdString = "LZW";
 const Word MaxFilesCount = 1000;
 const Word MaxChars = 256;
 const Word MaxChars2 = 2 * MaxChars;
 const Word MaxChars4 = 4 * MaxChars;
 const Word MaxChars8 = 8 * MaxChars;
 const Word LoadBufferSize = 51200U;
 const Word SaveBufferSize = 51200U;
 const Word NewDict = MaxChars;
 const Word EndCoding = MaxChars + 1;
 const Word UpBits = MaxChars + 2;
 const Byte MinBits = 9;
 const Word MinBitMask = ((Word)1 << MinBits) - 1;
 const Word MinBitMaskAdd = MinBitMask + 1;

 const char *ErrorMessages[] = {
  "Nedostatek pameti !",
  "Chyba pri otevirani zdrojoveho souboru !",
  "Chyba pri otevirani ciloveho souboru !",
  "Zadne soubory k zabaleni !",
  "Souboru vice nez max. pocet = 1000 !" };

 char Command;
 char IsError = 0;
 char **Args;
 fNameStr *ArgFiles;
 int ArgCount, FilesCount;
 int FileError;
 int fSource;
 int fDest;
 char NewDest;
 char fSourceOpen;
 char fDestOpen;
 FileInfo fSourceInfo, fDestInfo;
 Word LoadCount;
 Word SaveCount;
 Byte *LoadBuffer;
 Byte *SaveBuffer;
 Word LoadIndex;
 Word SaveIndex;
 char fLoadEnd;
 char fSourceEnd;
 Word DictSize;
 tEncDictItem *EncDictionary;
 tDecDictItem *DecDictionary;
 Word DictIndex;
 Word PhraseIndex;
 DWord BitBuffer;
 Byte BitCount;
 Byte PhraseIndexBitCount;
 Word BitMask;
 Word BitMaskAdd;
 Word NowPhraseCount, LastPhraseCount;
 Word LastPhraseIndex, NowPhraseIndex;
 Byte *NowPhrase, *LastPhrase;
 DWord Percent, PercentDiv, PercentAdd;
 Byte LastPercent;
 Byte PercentPos;
 DWord fPackedSize;
 char SaveEncoded,SaveDecoded;

void RestoreAll ()
{
 if (LoadBuffer != NULL) free (LoadBuffer);
 if (SaveBuffer != NULL) free (SaveBuffer);
 if (EncDictionary != NULL) free (EncDictionary);
 if (DecDictionary != NULL) free (DecDictionary);
 if (NowPhrase != NULL) free (NowPhrase);
 if (LastPhrase != NULL) free (LastPhrase);
 if (ArgFiles != NULL) free (ArgFiles);
 if (fSourceOpen) close (fSource);
 if (fDestOpen) close (fDest);
}//RestoreAll

void ErrorMsg (const char *text)
{
 cprintf ("\r\n"); cprintf (text);
 RestoreAll ();
 exit (1);
}//ErrorMsg

int CheckAns (int a, int n)
{
 int ans = getche ();
 fflush (stdin);
 while ((ans != a) && (ans != (a - 32)) && (ans != n) && (ans != (n - 32)))
 {
  cprintf ("\r\nOdpovez ano/ne ! ");
  ans = getche ();
  fflush (stdin);
 }//while
 return ans;
}//CheckAns

void InitSource ()
{
 LoadBuffer = (Byte *)malloc (LoadBufferSize);
 if (LoadBuffer == NULL) ErrorMsg (ErrorMessages[0]);
 fSourceOpen = 0;
 fSource = open (fSourceInfo.Name, O_RDONLY | O_BINARY);
 if (fSource == -1) ErrorMsg (ErrorMessages[1]); else fSourceOpen = 1;
 fSourceInfo.Size = filelength (fSource);
 SaveEncoded = 1;
 if (!fSourceInfo.Size) SaveEncoded = 0;
 fLoadEnd = 0;
 fSourceEnd = 0;
 LoadIndex = 0;
}//InitSource

void FreeSource ()
{
 if (LoadBuffer != NULL) free (LoadBuffer);
 if (fSourceOpen) { close (fSource); fSourceOpen = 0; }//if
}//FreeSource

void InitDest ()
{
 SaveBuffer = (Byte *)malloc (SaveBufferSize);
 if (SaveBuffer == NULL) ErrorMsg (ErrorMessages[0]);
 fDestOpen = 0;
 ffblk foundfile;
 NewDest = findfirst (fDestInfo.Name, &foundfile, 0);
 if (Command == 1)
  fDest = open (fDestInfo.Name, O_CREAT | O_APPEND | O_WRONLY | O_BINARY);
 else {
  SaveDecoded = 1;
  ffblk foundfile;
  if (!findfirst (fDestInfo.Name, &foundfile, 0)) {
   cprintf ("\r\nPrepsat soubor ");
   char k = 0;
   while (fDestInfo.Name[k] != 0) { cprintf ("%c", toupper (fDestInfo.Name[k])); k++; }//while
   cprintf (" ? (a/n) ");
   if (CheckAns ('a','n') == 'a')
    fDest = open (fDestInfo.Name, O_CREAT | O_TRUNC | O_WRONLY | O_BINARY);
   else
    SaveDecoded = 0;
  }//if
  else
   fDest = open (fDestInfo.Name, O_CREAT | O_APPEND | O_WRONLY | O_BINARY);
 }//else
 if (fDest == -1) ErrorMsg (ErrorMessages[2]); else fDestOpen = 1;
 SaveIndex = 0;
}//InitDest

void FreeDest ()
{
 if (SaveBuffer != NULL) free (SaveBuffer);
 if (fDestOpen) { close (fDest); fDestOpen = 0; }//if
}//FreeDest

void ReadSource ()
{
 LoadCount = read (fSource, LoadBuffer, LoadBufferSize);
 if (eof (fSource)) fLoadEnd = 1;
}//ReadSource

void WriteDest ()
{
 SaveCount = write (fDest, SaveBuffer, SaveIndex);
}//WriteDest

void InitPercent (FileInfo f)
{
 DWord a = 100;
 while (a < f.Size) a *= 10;
 PercentDiv = a;
 if (f.Size != 0) PercentAdd = (a * 100) / f.Size;
 else PercentAdd = 0;
 LastPercent = 0;
 Percent = 0;
 PercentPos = wherex ();
 fPackedSize = 0;
}//InitPercent

void WritePercent ()
{
 Percent += PercentAdd;
 Byte p = Percent / PercentDiv;
 if (p != LastPercent) {
  gotoxy (PercentPos, wherey ());
  cprintf ("%3u%%", p);
  LastPercent = p;
 }//if
}//WritePercent

void FullPercent ()
{
 gotoxy (PercentPos, wherey ());
 if (Command == 1)
  if (fSourceInfo.Size != 0)
   cprintf ("%5.1f%%", ((float)fPackedSize / fSourceInfo.Size) * 100);
  else cprintf ("100.0%%");
 else
  if (!SaveDecoded) cprintf ("  OK");
  else cprintf ("100%%");
}//FullPercent

void NewEncDict ()
{
 for (int i = 0; i < MaxChars; i++) EncDictionary[i].Succ = 0;
 DictIndex = MaxChars + 3;
 PhraseIndexBitCount = MinBits;
}//NewEncDict

void NewDecDict ()
{
 DictIndex = MaxChars + 3;
 PhraseIndexBitCount = MinBits;
 NowPhraseCount = 0;
 NowPhraseIndex = 0;
 BitMask = MinBitMask;
 BitMaskAdd = MinBitMaskAdd;
}//NewDecDict

void InitEncDict ()
{
 EncDictionary = (tEncDictItem *)malloc (DictSize * sizeof (tEncDictItem));
 if (EncDictionary == NULL) ErrorMsg (ErrorMessages[0]);
 for (int i = 0; i < MaxChars; i++) {
  EncDictionary[i].Letter = i;
  EncDictionary[i].Succ = 0;
 }//for
 DictIndex = MaxChars + 3;
 PhraseIndexBitCount = MinBits;
}//InitEncDict

void FreeEncDict ()
{
 if (EncDictionary != NULL) free (EncDictionary);
}//FreeEncDict

void InitDecDict ()
{
 DecDictionary = (tDecDictItem *)malloc (DictSize * sizeof (tDecDictItem));
 if (DecDictionary == NULL) ErrorMsg (ErrorMessages[0]);
 NowPhrase = (Byte *)malloc (DictSize);
 if (NowPhrase == NULL) ErrorMsg (ErrorMessages[0]);
 LastPhrase = (Byte *)malloc (DictSize);
 if (LastPhrase == NULL) ErrorMsg (ErrorMessages[0]);
 for (int i = 0; i < MaxChars; i++) DecDictionary[i].Letter = i;
 DictIndex = MaxChars + 3;
 PhraseIndexBitCount = MinBits;
 NowPhraseCount = 0;
 NowPhraseIndex = 0;
 BitMask = MinBitMask;
 BitMaskAdd = MinBitMaskAdd;
}//InitDecDict

void FreeDecDict ()
{
 if (DecDictionary != NULL) free (DecDictionary);
 if (NowPhrase != NULL) free (NowPhrase);
 if (LastPhrase != NULL) free (LastPhrase);
}//FreeDecDict

void CheckLoadBufferEmpty ()
{
 if ((LoadIndex == LoadCount) && (!fLoadEnd)) {
  ReadSource (); LoadIndex = 0;
 }//if
}//CheckLoadBufferEmpty

void CheckSaveBufferFull ()
{
 fPackedSize++;
 if (SaveIndex == SaveBufferSize) {
  WriteDest (); SaveIndex = 0;
 }//if
}//CheckSaveBufferFull

void SaveIndexBits (Word value)
{
 BitBuffer += ((DWord)value << BitCount);
 BitCount += PhraseIndexBitCount;
 while (BitCount >= 8) {
  SaveBuffer[SaveIndex] = (BitBuffer & BitMask);
  SaveIndex++;
  CheckSaveBufferFull ();
  BitBuffer >>= 8;
  BitCount -= 8;
 }//while
}//SaveIndexBits

Word LoadIndexBits ()
{
 Word phrase;
 while (BitCount < PhraseIndexBitCount) {
  BitBuffer += ((DWord)LoadBuffer[LoadIndex] << BitCount);
  LoadIndex++;
  CheckLoadBufferEmpty ();
  if (LoadIndex == LoadCount) { fSourceEnd = 1; break; }//if
  BitCount += 8;
 }//while
 phrase = (BitBuffer & BitMask);
 BitBuffer >>= PhraseIndexBitCount;
 BitCount -= PhraseIndexBitCount;
 return phrase;
}//LoadIndexBits

void CheckEncDictFull ()
{
 switch (DictIndex) {
  case MaxChars2 : {
   SaveIndexBits (UpBits);
   PhraseIndexBitCount++;
   break;
  }//case
  case MaxChars4 : {
   SaveIndexBits (UpBits);
   PhraseIndexBitCount++;
   break;
  }//case
  case MaxChars8 : {
   SaveIndexBits (UpBits);
   PhraseIndexBitCount++;
   break;
  }//case
 }//switch
 if (DictIndex == DictSize) {
  SaveIndexBits (NewDict);
  NewEncDict ();
 }//if
}//CheckEncDictFull

Word FindEncPhrase ()
{
 Word phrase,jump,succ,neib;
 jump = LoadBuffer[LoadIndex];
 do {
  succ = EncDictionary[jump].Succ;
  neib = EncDictionary[jump].Neib;
  if (EncDictionary[jump].Letter == LoadBuffer[LoadIndex]) {
   phrase = jump; LoadIndex++; CheckLoadBufferEmpty (); WritePercent ();
   if (LoadIndex == LoadCount) { fSourceEnd = 1; break; }//if
   if (succ != 0) jump = succ; else break;
  }//if
  else if (neib != 0) jump = neib; else break;
 } while (1);
 return phrase;
}//FindEncPhrase

void FindDecPhrase ()
{
 Word jump;
 LastPhraseCount = NowPhraseCount;
 for (int i = 0; i < NowPhraseCount; i++)
  LastPhrase[i] = NowPhrase[i];
 LastPhraseIndex = NowPhraseIndex;
 NowPhraseIndex = PhraseIndex;
 NowPhraseCount = 0;
 if (PhraseIndex == DictIndex) {
  NowPhrase[0] = LastPhrase[LastPhraseCount - 1];
  NowPhraseCount++;
  for (int j = 0; j < LastPhraseCount; j++) {
   NowPhrase[j + 1] = LastPhrase[j];
   NowPhraseCount++;
  }//for
 }//if
 else {
  jump = PhraseIndex;
  do {
   NowPhrase[NowPhraseCount] = DecDictionary[jump].Letter;
   NowPhraseCount++;
   if (jump < MaxChars) break;
   else jump = DecDictionary[jump].Pred;
  } while (1);
 }//else
 for (int k = NowPhraseCount - 1; k > 0; k--) {
  SaveBuffer[SaveIndex] = NowPhrase[k];
  SaveIndex++;
  CheckSaveBufferFull ();
  WritePercent ();
 }//for
 SaveBuffer[SaveIndex] = NowPhrase[0];
 SaveIndex++;
 CheckSaveBufferFull ();
 WritePercent ();
}//FindDecPhrase

void NewEncPhrase ()
{
 Word jump;
 if (EncDictionary[PhraseIndex].Succ == 0)
  EncDictionary[PhraseIndex].Succ = DictIndex;
 else {
  jump = EncDictionary[PhraseIndex].Succ;
  do {
   if (EncDictionary[jump].Neib == 0) {
    EncDictionary[jump].Neib = DictIndex; break;
   }//if
   else jump = EncDictionary[jump].Neib;
  } while (1);
 }//else
 EncDictionary[DictIndex].Letter = LoadBuffer[LoadIndex];
 EncDictionary[DictIndex].Succ = 0;
 EncDictionary[DictIndex].Neib = 0;
 DictIndex++; CheckEncDictFull ();
}//NewEncPhrase

void NewDecPhrase ()
{
 if (LastPhraseCount != 0) {
  DecDictionary[DictIndex].Letter = NowPhrase[NowPhraseCount - 1];
  DecDictionary[DictIndex].Pred = LastPhraseIndex;
  DictIndex++;
 }//if
}//NewDecPhrase

void Encode ()
{
 BitBuffer = 0;
 BitCount = 0;
 BitMask = 0x00FF;
 InitEncDict ();
 do {
  if (SaveEncoded) {
   PhraseIndex = FindEncPhrase ();
   SaveIndexBits (PhraseIndex);
  }//if
  else fSourceEnd = 1;
  if (fSourceEnd) {
   SaveIndexBits (EndCoding);
   SaveIndexBits (0x0000);
   WriteDest ();
   SaveIndex = 0;
   break;
  }//if
  NewEncPhrase ();
 } while (1);
 FreeEncDict ();
}//Encode

void Decode ()
{
 BitBuffer = 0;
 BitCount = 0;
 InitDecDict ();
 do {
  PhraseIndex = LoadIndexBits ();
  if (PhraseIndex == NewDict) { NewDecDict (); continue; }//if
  if (PhraseIndex == EndCoding) { WriteDest (); break; }//if
  if (PhraseIndex == UpBits) {
   PhraseIndexBitCount++;
   BitMask += BitMaskAdd;
   BitMaskAdd <<= 1;
   continue;
  }//if
  if (SaveDecoded) {
   FindDecPhrase ();
   NewDecPhrase ();
  }//if
 } while (1);
 FreeDecDict ();
}//Decode

void Pack ()
{
 fDestInfo.Name = Args[2];
 InitDest ();
 if (NewDest) {
  for (int i = 0; i < 3; i++)
   SaveBuffer[SaveIndex + i] = IdString[i];
  SaveIndex += 3;
  cprintf ("\r\nVytvarim ");
 }//if
 else cprintf ("\r\nZpracovavam ");
 cprintf ("balik %s\n", strupr (fDestInfo.Name));
 gotoxy (1, wherey ());
 int loop = 0;
 while (loop < FilesCount) {
  fSourceInfo.Name = ArgFiles[loop];
  InitSource ();
  cprintf ("\r\nPribaluji ");
  int j = 0;
  while (fSourceInfo.Name[j] != 0) { cprintf ("%c", toupper (fSourceInfo.Name[j])); j++; }//while
  cprintf (" ");
  while (j < 20) { cprintf ("."); j++; }//while
  cprintf (" ");
  char ln = strlen (fSourceInfo.Name);
  for (int k = 0; k < ln; k++) {
   SaveBuffer[SaveIndex] = fSourceInfo.Name[k];
   SaveIndex++;
   CheckSaveBufferFull ();
  }//for
  SaveBuffer[SaveIndex] = '*';
  SaveIndex++;
  CheckSaveBufferFull ();
  DWord size = fSourceInfo.Size;
  for (int l = 0; l < 4; l++) {
   SaveBuffer[SaveIndex] = size;
   size >>= 8;
   SaveIndex++;
   CheckSaveBufferFull ();
  }//for
  SaveBuffer[SaveIndex] = '#';
  SaveIndex++;
  CheckSaveBufferFull ();
  InitPercent (fSourceInfo);
  ReadSource ();
  Encode ();
  FullPercent ();
  FreeSource ();
  loop++;
 }//while
 FreeDest ();
 cprintf ("\r\n\r\n     Souboru pribaleno: %i", loop);
}//Pack

void UnPack ()
{
 fSourceInfo.Name = Args[2];
 InitSource ();
 cprintf ("\r\nZpracovavam balik %s\n", strupr (fSourceInfo.Name));
 gotoxy (1, wherey ());
 ReadSource ();
 LoadIndex += 3;
 int loop = 0, unpacked = 0;
 do {
  while (LoadBuffer[LoadIndex] == 0) {
   LoadIndex++;
   CheckLoadBufferEmpty ();
  }//while
  int k = 0;
  while (LoadBuffer[LoadIndex] != '*') {
   fDestInfo.Name[k] = LoadBuffer[LoadIndex];
   LoadIndex++;
   CheckLoadBufferEmpty ();
   k++;
  }//for
  fDestInfo.Name[k] = 0;
  LoadIndex++;
  CheckLoadBufferEmpty ();
  Byte bitpos = 0;
  for (int l = 0; l < 4; l++) {
   fDestInfo.Size += ((DWord)LoadBuffer[LoadIndex] << bitpos);
   bitpos += 8;
   LoadIndex++;
   CheckLoadBufferEmpty ();
  }//for
  if (LoadBuffer[LoadIndex] == '#') {
   LoadIndex++;
   CheckLoadBufferEmpty ();
   goto StartDecoding;
  }//if
  StartDecoding:
  InitDest ();
  if (SaveDecoded) cprintf ("\r\nVybaluji "); else cprintf ("\r\nPreskakuji ");
  k = 0;
  while (fDestInfo.Name[k] != 0) { cprintf ("%c", toupper (fDestInfo.Name[k])); k++; }//while
  cprintf (" ");
  while (k < 20) { cprintf ("."); k++; }//while
  cprintf (" ");
  InitPercent (fDestInfo);
  Decode ();
  FullPercent ();
  FreeDest ();
  if ((fLoadEnd) && ((LoadIndex + 1) == LoadCount)) fSourceEnd = 1;
  loop++;
  if (SaveDecoded) unpacked++;
 } while (!fSourceEnd);
 FreeSource ();
 cprintf ("\r\n\r\n     Souboru vybaleno: %i", unpacked);
}//UnPack

void ProccessParams ()
{
 char wantfiles = 0;
 if (ArgCount < 3) IsError = 1;
 char *commstr = Args[1];
 Command = 0;
 if (!stricmp (commstr, "a")) { Command = 1; wantfiles = 1; }//if
 if (!stricmp (commstr, "e")) Command = 2;
 if (wantfiles) {
  ArgFiles = (fNameStr *)malloc (MaxFilesCount * sizeof (fNameStr));
  if (ArgFiles == NULL) ErrorMsg (ErrorMessages[0]);
  FilesCount = 0;
  int j = 3, ok;
  ffblk foundfile;
  while (j < ArgCount) {
   ok = findfirst (Args[j], &foundfile, 0);
   while (!ok) {
    if (FilesCount == MaxFilesCount) ErrorMsg (ErrorMessages[4]);
    for (int i = 0; i < 13; i++)
     ArgFiles[FilesCount][i] = foundfile.ff_name[i];
    FilesCount++;
    ok = findnext (&foundfile);
   }//while
   j++;
  }//while
  if ((FilesCount == 0) && (!IsError)) ErrorMsg (ErrorMessages[3]);
 }//if
}//ProccessParams

void main (int argc, char *argv[])
{
 DictSize = 4096;
 Args = argv;
 ArgCount = argc;
 ProccessParams ();
 if (!IsError) {
  switch (Command) {
   case 1 : {
    if (ArgCount > 3) Pack (); else IsError = 1;
    break;
   }//case
   case 2 : {
    UnPack ();
    break;
   }//case
   default : IsError = 1;
  }//switch
  RestoreAll ();
 }//if
 if (IsError) {
  cprintf ("\r\n  LZW      Copyright (c) 1999 Jan Outrata"
           "\r\n"
           "\r\nPouziti:     LZW <prikaz> <balik> [<soubory ...>]"
           "\r\n"
           "\r\n<Prikazy>"
           "\r\n  a     Pribal soubory do baliku"
           "\r\n  e     Vybal soubory do aktualniho adresare"
           "\r\n\r\n");
 }//if
}//main